
/* ******************************************************************************* */
/*                                                                                 */
/*  Practica de Intelligencia Artificial II                                       */
/*  Implementacio de l'algorisme de classificacio de dades multidimensionals:      */
/*  SOM (Self Oriented Map)                                                        */   
/*  Classe SOM: conte la interficie grafica de l'aplicacio                         */
/*  Autors: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma                */
/*                                                                                 */
/* ******************************************************************************* */

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Interficie extends JFrame implements FocusListener 
{
   private JFileChooser dialegFitxer = new JFileChooser();;
   private JButton botoDialeg;
   private JButton botoInici;
   private JButton botoParametres;
   private JButton taulaPatrons[][];
   private JLabel labelEstat;
   private Som classificador;
   private JTextField textA, textB, textC, textD, textE, textF, textG, textH, textI;
   private JLabel labelA, labelB, labelC, labelD, labelE, labelF, labelG, labelH, labelI;
   private JFrame finestraResultats;
   private int dimX, dimY, tamPatro;
   private int numEpoques, numClasses;
   private int multiplicador;
   private float aprenentatge, sigma;
   private int radiVeinatge;
   

   public void setNativeLookAndFeel() 
   {
      try {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      } catch(Exception e) {}
   }

   public Interficie() 
   {  
      super("Self Organizing Map - Intelligencia Artificial II");
      setNativeLookAndFeel();
      addWindowListener(new ExitListener());
      
      botoParametres = new JButton("Establir Parametres"); // new ImageIcon("imatges/fitxer.gif"));
      botoParametres.addActionListener(new ParametresListener());
      botoParametres.setEnabled(true);
                  
      botoDialeg = new JButton("Seleccionar Fitxer", new ImageIcon("imatges/fitxer.gif"));
      botoDialeg.addActionListener(new FitxerListener());
      botoDialeg.setEnabled(false);
      
      botoInici = new JButton("Iniciar Programa");//, new ImageIcon("imatges/xarxa.gif"));
      botoInici.addActionListener(new IniciListener());
      botoInici.setEnabled(false);
      
      JPanel panellBotons = new JPanel();
      panellBotons.add(botoParametres);
      panellBotons.add(botoDialeg);
      panellBotons.add(botoInici);
      
      textA = new JTextField();
      textA.setColumns(10);
      textA.setText("10");
      textB = new JTextField();
      textB.setColumns(10);
      textB.setText("10");
      textC = new JTextField();
      textC.setColumns(10);
      textC.setText("4");
      textD = new JTextField();
      textD.setColumns(10);
      textD.setText("10");
      textE = new JTextField();
      textE.setColumns(10);
      textE.setText("10");
      textF = new JTextField();
      textF.setColumns(10);
      textF.setText("3");
      textG = new JTextField();
      textG.setColumns(10);
      textG.setText("0.8");
      textH = new JTextField();
      textH.setColumns(10);
      textH.setText("0.8");
      textI = new JTextField();
      textI.setColumns(10);
      textI.setText("3");
      labelA = new JLabel("Dimensio X malla neurones...........");
      labelA.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelB = new JLabel("Dimensio Y malla neurones...........");
      labelB.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelC = new JLabel("Nombre d'elements de cada patro.....");
      labelC.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelD = new JLabel("Nombre d'epoques inicials...........");
      labelD.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelE = new JLabel("Multiplicador d'epoques.............");
      labelE.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelF = new JLabel("Nombre de classes...................");
      labelF.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelG = new JLabel("Taxa d'aprenentatge ( ]0,1[ ).......");
      labelG.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelH = new JLabel("Sigma ( ]0,1[ ).....................");
      labelH.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      labelI = new JLabel("Radi veinatge inicial...............");
      labelI.setFont(new Font("COURIER NEW",Font.PLAIN,11));
      JPanel panellA = new JPanel();
      panellA.add(labelA);
      panellA.add(textA);
      JPanel panellB = new JPanel();
      panellB.add(labelB);
      panellB.add(textB);
      JPanel panellC = new JPanel();
      panellC.add(labelC);
      panellC.add(textC);
      JPanel panellD = new JPanel();
      panellD.add(labelD);
      panellD.add(textD);
      JPanel panellE = new JPanel();
      panellE.add(labelE);
      panellE.add(textE);
      JPanel panellF = new JPanel();
      panellF.add(labelF);
      panellF.add(textF);
      JPanel panellG = new JPanel();
      panellG.add(labelG);
      panellG.add(textG);
      JPanel panellH = new JPanel();
      panellH.add(labelH);
      panellH.add(textH);
      JPanel panellI = new JPanel();
      panellI.add(labelI);
      panellI.add(textI);
      
      JPanel panellDades = new JPanel();
      panellDades.setLayout(new GridLayout(9,2));
      panellDades.add(panellA);
      panellDades.add(panellB);
      panellDades.add(panellC);
      panellDades.add(panellD);
      panellDades.add(panellE);
      panellDades.add(panellF);
      panellDades.add(panellH);
      panellDades.add(panellG);
      panellDades.add(panellI);

      labelEstat = new JLabel("Escolliu el fitxer de patrons.",JLabel.CENTER);
      JPanel panellEstat = new JPanel();
      panellEstat.add(labelEstat);
      
      Container contenidor = this.getContentPane();
      contenidor.add(panellEstat,BorderLayout.SOUTH);
      contenidor.add(panellDades,BorderLayout.NORTH);
      contenidor.add(panellBotons,BorderLayout.CENTER);

      botoParametres.grabFocus();
      pack();
      setVisible(true);
      show();  
   }

   public static void main(String args[]) 
   {
      JFrame frame = new Interficie();
   }  

   public Color obtenirColorMalla(float valorMalla)
   {
      String s = String.valueOf(valorMalla);
      int posPunt = s.lastIndexOf('.');
      s = s.substring(0,posPunt);
      int valor = Integer.parseInt(s);
      switch(valor) {
         case(1):
            return Color.BLUE;
         case(2):
            return Color.RED;          
         case(3):
            return Color.GREEN;
         case(4):
            return Color.CYAN;
         case(5):
            return Color.GRAY;
         case(6):
            return Color.ORANGE;
         case(7):
            return Color.YELLOW;
         case(8):
            return Color.PINK;
         case(9):
            return Color.BLACK;
         default:
            return Color.WHITE;
      }
   }

   public void guardarPatronsFitxer(Collection patrons[][])
   {
      try {
         File f = new File("dadesSom.txt");
         FileWriter fw = new FileWriter(f);
         BufferedWriter buffer = new BufferedWriter(fw);
         PrintWriter sortida = new PrintWriter(buffer);
         for (int i = 0; i < dimX; i++) {
            for (int j = 0; j < dimY; j++) {
               Iterator it = patrons[i][j].iterator();
               sortida.println("Patrons classificats en la neurona " + i + "," + j);
               while (it.hasNext()) {
                  Integer patro = (Integer)it.next();
                  sortida.println(patro.intValue());
               }
            }
         }
         sortida.close();
      }
      catch (IOException ex) {}
   }

   public void crearFinestraResultats(Hashtable ht)
   {
      float malla[][] = (float [][])ht.get("malla");
      finestraResultats = new JFrame("Resultats de l'execucio de l'algorisme SOM");
      taulaPatrons = new JButton[dimX][dimY];
      JPanel panellEtiquetes = new JPanel();
      panellEtiquetes.setLayout(new GridLayout(dimX,dimY));
      for(int i = 0; i < dimX; i++) {
         for(int j = 0; j < dimY; j++) {
            taulaPatrons[i][j] = new JButton();
            taulaPatrons[i][j].setSize(50,50);
            taulaPatrons[i][j].setText(i + "," + j);
            Color c = obtenirColorMalla(malla[i][j]);
            taulaPatrons[i][j].setBackground(c);
            if (c == Color.WHITE) {
               taulaPatrons[i][j].setForeground(Color.BLACK);
            }
            else {
               taulaPatrons[i][j].setForeground(Color.WHITE);           	
            }
            panellEtiquetes.add(taulaPatrons[i][j]);
         }
      }
      Container contingut = finestraResultats.getContentPane();
      contingut.add(panellEtiquetes,BorderLayout.CENTER);

      finestraResultats.pack();
      finestraResultats.setVisible(true);
      finestraResultats.show();
      
      Collection patrons[][] = (Collection [][])ht.get("patrons");
      guardarPatronsFitxer(patrons);
   }

   public void focusGained(FocusEvent e)
   {
      this.repaint();
   }

   public void focusLost(FocusEvent e)
   {
      this.transferFocus();
   }

   private class ExitListener extends WindowAdapter
   {
      public void windowClosing(WindowEvent event) 
      {
         System.exit(0);
      }
   }

   private class ParametresListener implements ActionListener 
   {
      public void actionPerformed(ActionEvent e) 
      {
         String cadenaA = textA.getText();
         String cadenaB = textB.getText();
         String cadenaC = textC.getText();
         String cadenaD = textD.getText();
         String cadenaE = textE.getText();
         String cadenaF = textF.getText();
         String cadenaG = textG.getText();
         String cadenaH = textH.getText();
         String cadenaI = textI.getText();
         boolean correcte = true;
         if (!cadenaA.equals("") && !cadenaB.equals("") && !cadenaC.equals("") &&
             !cadenaD.equals("") && !cadenaE.equals("") && !cadenaF.equals("") &&
             !cadenaG.equals("") && !cadenaH.equals("") && !cadenaI.equals("")) { 
            try {
               dimX = Integer.parseInt(cadenaA);
               dimY = Integer.parseInt(cadenaB);
               tamPatro = Integer.parseInt(cadenaC);
               numEpoques = Integer.parseInt(cadenaD);
               multiplicador = Integer.parseInt(cadenaE);
               numClasses = Integer.parseInt(cadenaF);
               aprenentatge = Float.parseFloat(cadenaG);
               sigma = Float.parseFloat(cadenaH);
               radiVeinatge = Integer.parseInt(cadenaI);
            }
            catch(Exception ex) {
               correcte = false;
               labelEstat.setText("Els valors dels parametres no son correctes.");
            }
         }
         else {
            correcte = false;
            labelEstat.setText("Cal omplir tots els camps de text per continuar."); 		   
         }                    
         if (correcte) {
            botoDialeg.setEnabled(true);
            botoDialeg.grabFocus();
            botoParametres.setEnabled(false);
         }
      }
   }
   
   private class FitxerListener implements ActionListener 
   {
      public void actionPerformed(ActionEvent e) 
      {
         int returnVal = dialegFitxer.showOpenDialog(Interficie.this);
         if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = dialegFitxer.getSelectedFile();
            classificador = new Som(dimX,dimY,tamPatro,numEpoques,numClasses,null,
                                 	multiplicador,aprenentatge,sigma,radiVeinatge);
            try {
               classificador.obtenirPatrons(file);
               botoDialeg.setEnabled(false);
               botoInici.setEnabled(true);
               botoInici.grabFocus();
               labelEstat.setText("Fitxer de patrons carregat correctament, podeu iniciar l'algorisme.");
            }
            catch (ExcepcioFitxer ex) {
               labelEstat.setText("No s'ha pogut carregar correctament el fitxer especificat.");
            }
         } 
      }
   }
  
   private class IniciListener implements ActionListener 
   {
      public void actionPerformed(ActionEvent e) 
      {
         botoInici.setEnabled(false);
         classificador.execucioAlgorismeSOM();
         Hashtable ht = classificador.classificarDades();
         classificador.emmagatzemarMalla("mallaEntrenada.txt");
         crearFinestraResultats(ht);
         botoParametres.setEnabled(true);
         botoParametres.grabFocus();
      }
   }
  
}

